(* tests on PolyMinus
   author: Walther Neuper
   WN071207,
   (c) due to copyright terms

use"../smltest/IsacKnowledge/polyminus.sml";
use"polyminus.sml";
*)
val thy = PolyMinus.thy;

"-----------------------------------------------------------------";
"table of contents -----------------------------------------------";
"-----------------------------------------------------------------";
"----------- watch order_add_mult  -------------------------------";
"----------- build predicate for +- ordering ---------------------";
"----------- build fasse_zusammen --------------------------------";
"----------- build verschoenere ----------------------------------";
"----------- met simplification for_polynomials with_minus -------";
"----------- pbl polynom vereinfachen ----------------------------";
"----------- met probe fuer_polynom ------------------------------";
"----------- pbl polynom probe -----------------------------------";
"----------- pbl klammer polynom vereinfachen p.34 ---------------";
"----------- try fun applyTactics --------------------------------";
"-----------------------------------------------------------------";
"-----------------------------------------------------------------";
"-----------------------------------------------------------------";


"----------- watch order_add_mult  -------------------------------";
"----------- watch order_add_mult  -------------------------------";
"----------- watch order_add_mult  -------------------------------";
"----- with these simple variables it works...";
trace_rewrite:=true;
trace_rewrite:=false;
val t = str2term "((a + d) + c) + b";
val Some (t,_) = rewrite_set_ thy false order_add_mult t; term2str t;
if term2str t = "a + (b + (c + d))" then ()
else raise error "polyminus.sml 1 watch order_add_mult";
trace_rewrite:=false;

"----- the same stepwise...";
val od = ord_make_polynomial true Poly.thy;
val t = str2term "((a + d) + c) + b";
"((a + d) + c) + b"; 
val Some (t,_) = rewrite_ thy od e_rls true real_add_commute t; term2str t;
"b + ((a + d) + c)";
val Some (t,_) = rewrite_ thy od e_rls true real_add_commute t; term2str t;
"b + (c + (a + d))";
val Some (t,_) = rewrite_ thy od e_rls true real_add_left_commute t;term2str t;
"b + (a + (c + d))";
val Some (t,_) = rewrite_ thy od e_rls true real_add_left_commute t;term2str t;
"a + (b + (c + d))";
if term2str t = "a + (b + (c + d))" then ()
else raise error "polyminus.sml 2 watch order_add_mult";

"----- if parentheses are right, left_commute is (almost) sufficient...";
val t = str2term "a + (d + (c + b))";
"a + (d + (c + b))";
val Some (t,_) = rewrite_ thy od e_rls true real_add_left_commute t;term2str t;
"a + (c + (d + b))";
val Some (t,_) = rewrite_ thy od e_rls true real_add_commute t;term2str t;
"a + (c + (b + d))";
val Some (t,_) = rewrite_ thy od e_rls true real_add_left_commute t;term2str t;
"a + (b + (c + d))";

"----- but we do not want the parentheses at right; thus: cond.rew.";
"WN0712707 complicated monomials do not yet work ...";
val t = str2term "((5*a + 4*d) + 3*c) + 2*b";
val Some (t,_) = rewrite_set_ thy false order_add_mult t; term2str t;
if term2str t = "2 * b + (3 * c + (4 * d + 5 * a))" then ()
else raise error "polyminus.sml: order_add_mult changed";

"----- here we see rew_sub going into subterm with ord.rew....";
val od = ord_make_polynomial false Poly.thy;
val t = str2term "b + a + c + d";
val Some (t,_) = rewrite_ thy od e_rls false real_add_commute t; term2str t;
val Some (t,_) = rewrite_ thy od e_rls false real_add_commute t; term2str t;
(*@@@ rew_sub gosub: t = d + (b + a + c)
  @@@ rew_sub begin: t = b + a + c*)


"----------- build predicate for +- ordering ---------------------";
"----------- build predicate for +- ordering ---------------------";
"----------- build predicate for +- ordering ---------------------";
"a" < "b";
"ba" < "ab";
"123" < "a"; (*unused due to ---vvv*)
"12" < "3"; (*true !!!*)

" a kleiner b ==> (b + a) = (a + b)";
str2term "aaa";
str2term "222 * aaa";

case eval_kleiner 0 0 (str2term "12 kleiner 9") 0 of
    Some ("12 kleiner 9 = False", _) => ()
  | _ => raise error "polyminus.sml: 12 kleiner 9 = False";

case eval_kleiner 0 0 (str2term "a kleiner b") 0 of
    Some ("a kleiner b = True", _) => ()
  | _ => raise error "polyminus.sml: a kleiner b = True";

"----- compare tausche_plus with real_num_collect";
val od = dummy_ord;

val erls = erls_ordne_alphabetisch;
val t = str2term "b + a";
val Some (t,_) = rewrite_ thy od erls false tausche_plus t; term2str t;
if term2str t = "a + b" then ()
else raise error "polyminus.sml: ordne_alphabetisch1 b + a";

val erls = Atools_erls;
val t = str2term "2*a + 3*a";
val Some (t,_) = rewrite_ thy od erls false real_num_collect t; term2str t;

"----- test rewrite_, rewrite_set_";
trace_rewrite:=true;
val erls = erls_ordne_alphabetisch;
val t = str2term "b + a";
val Some (t,_) = rewrite_set_ thy false ordne_alphabetisch t; term2str t;
if term2str t = "a + b" then ()
else raise error "polyminus.sml: ordne_alphabetisch a + b";

val t = str2term "2*b + a";
val Some (t,_) = rewrite_set_ thy false ordne_alphabetisch t; term2str t;
if term2str t = "a + 2 * b" then ()
else raise error "polyminus.sml: ordne_alphabetisch a + 2 * b";

val t = str2term "a + c + b";
val Some (t,_) = rewrite_set_ thy false ordne_alphabetisch t; term2str t;
if term2str t = "a + b + c" then ()
else raise error "polyminus.sml: ordne_alphabetisch a + b + c";

"----- rewrite goes into subterms";
val t = str2term "a + c + b + d";
val Some (t,_) = rewrite_ thy od erls false tausche_plus_plus t; term2str t;
if term2str t = "a + b + c + d" then ()
else raise error "polyminus.sml: ordne_alphabetisch1 a + b + c + d";

val t = str2term "a + c + d + b";
val Some (t,_) = rewrite_set_ thy false ordne_alphabetisch t; term2str t;
if term2str t = "a + b + c + d" then ()
else raise error "polyminus.sml: ordne_alphabetisch2 a + b + c + d";

"----- here we see rew_sub going into subterm with cond.rew....";
val t = str2term "b + a + c + d";
val Some (t,_) = rewrite_ thy od erls false tausche_plus t; term2str t;
if term2str t = "a + b + c + d" then ()
else raise error "polyminus.sml: ordne_alphabetisch3 a + b + c + d";

"----- compile rls for the most complicated terms";
val t = str2term "5*e + 6*f - 8*g - 9 - 7*e - 4*f + 10*g + 12";
"5 * e + 6 * f - 8 * g - 9 - 7 * e - 4 * f + 10 * g + 12";
val Some (t,_) = rewrite_set_ thy false ordne_alphabetisch t; 
if term2str t = "- 9 + 12 + 5 * e - 7 * e + 6 * f - 4 * f - 8 * g + 10 * g"
then () else raise error "polyminus.sml: ordne_alphabetisch finished";


"----------- build fasse_zusammen --------------------------------";
"----------- build fasse_zusammen --------------------------------";
"----------- build fasse_zusammen --------------------------------";
val t = str2term "- 9 + 12 + 5 * e - 7 * e + 6 * f - 4 * f - 8 * g + 10 * g";
val Some (t,_) = rewrite_set_ thy false fasse_zusammen t;
if term2str t = "3 + -2 * e + 2 * f + 2 * g" then ()
else raise error "polyminus.sml: fasse_zusammen finished";

"----------- build verschoenere ----------------------------------";
"----------- build verschoenere ----------------------------------";
"----------- build verschoenere ----------------------------------";
val t = str2term "3 + -2 * e + 2 * f + 2 * g";
val Some (t,_) = rewrite_set_ thy false verschoenere t;
if term2str t = "3 - 2 * e + 2 * f + 2 * g" then ()
else raise error "polyminus.sml: verschoenere 3 + -2 * e ...";

trace_rewrite:=true;
trace_rewrite:=false;

"----------- met simplification for_polynomials with_minus -------";
"----------- met simplification for_polynomials with_minus -------";
"----------- met simplification for_polynomials with_minus -------";
val str = 
"Script SimplifyScript (t_::real) =                \
\  (((Try (Rewrite_Set ordne_alphabetisch False)) @@     \
\    (Try (Rewrite_Set fasse_zusammen False)) @@     \
\    (Try (Rewrite_Set verschoenere False))) t_)"
val sc = ((inst_abs thy) o term_of o the o (parse thy)) str;
atomty sc;


"----------- pbl polynom vereinfachen ----------------------------";
"----------- pbl polynom vereinfachen ----------------------------";
"----------- pbl polynom vereinfachen ----------------------------";
states:=[];
CalcTree [(["term (5*e + 6*f - 8*g - 9 - 7*e - 4*f + 10*g + 12)",
	    "normalform N"],
	   ("PolyMinus.thy",["polynom","vereinfachen"],
	    ["simplification","for_polynomials","with_minus"]))];
moveActiveRoot 1;
autoCalculate 1 CompleteCalc;
val ((pt,p),_) = get_calc 1;
if p = ([], Res) andalso 
   term2str (get_obj g_res pt (fst p)) = "3 - 2 * e + 2 * f + 2 * g"
then () else raise error "polyminus.sml: Vereinfache (3 - 2 * e + 2 * f...";
show_pt pt;

"----------- met probe fuer_polynom ------------------------------";
"----------- met probe fuer_polynom ------------------------------";
"----------- met probe fuer_polynom ------------------------------";
val str = 
"Script ProbeScript (e_::bool) (ws_::bool list) =\
\ (let e_ = Take e_;                             \
\      e_ = Substitute ws_ e_                    \
\ in (Repeat((Try (Repeat (Calculate times))) @@  \
\            (Try (Repeat (Calculate plus ))) @@  \
\            (Try (Repeat (Calculate minus))))) e_)"
val sc = ((inst_abs thy) o term_of o the o (parse thy)) str;
atomty sc;


"----------- pbl polynom probe -----------------------------------";
"----------- pbl polynom probe -----------------------------------";
"----------- pbl polynom probe -----------------------------------";
states:=[];
CalcTree [(["Pruefe (5*e + 6*f - 8*g - 9 - 7*e - 4*f + 10*g + 12 =\
	    \3 - 2 * e + 2 * f + 2 * g)",
	    "mitWert [e = 1, f = 2, g = 3]",
	    "Geprueft b"],
	   ("PolyMinus.thy",["polynom","probe"],
	    ["probe","fuer_polynom"]))];
moveActiveRoot 1;
autoCalculate 1 CompleteCalc;
val ((pt,p),_) = get_calc 1;
if p = ([], Res) andalso term2str (get_obj g_res pt (fst p)) = "11 = 11"
then () else raise error "polyminus.sml: Probe 11 = 11";
show_pt pt;


"----------- pbl klammer polynom vereinfachen p.34 ---------------";
"----------- pbl klammer polynom vereinfachen p.34 ---------------";
"----------- pbl klammer polynom vereinfachen p.34 ---------------";
states:=[];
CalcTree [(["term (2*u - 5 - (3 - 4*u) + (8*u + 9))",
	    "normalform N"],
	   ("PolyMinus.thy",["klammer","polynom","vereinfachen"],
	    ["simplification","for_polynomials","with_parentheses"]))];
moveActiveRoot 1;
autoCalculate 1 CompleteCalc;
val ((pt,p),_) = get_calc 1;
if p = ([], Res) andalso 
   term2str (get_obj g_res pt (fst p)) = "1 + 14 * u"
then () else raise error "polyminus.sml: Vereinfache (2*u - 5 - (3 - ...";
show_pt pt;

"----- probe p.34 -----";
states:=[];
CalcTree [(["Pruefe (2*u - 5 - (3 - 4*u) + (8*u + 9) = 1 + 14 * u)",
	    "mitWert [u = 2]",
	    "Geprueft b"],
	   ("PolyMinus.thy",["polynom","probe"],
	    ["probe","fuer_polynom"]))];
moveActiveRoot 1;
autoCalculate 1 CompleteCalc;
val ((pt,p),_) = get_calc 1;
if p = ([], Res) andalso term2str (get_obj g_res pt (fst p)) = "29 = 29"
then () else raise error "polyminus.sml: Probe 29 = 29";
show_pt pt;


"----------- try fun applyTactics --------------------------------";
"----------- try fun applyTactics --------------------------------";
"----------- try fun applyTactics --------------------------------";
states:=[];
CalcTree [(["term (5*e + 6*f - 8*g - 9 - 7*e - 4*f + 10*g + 12)",
	    "normalform N"],
	   ("PolyMinus.thy",["polynom","vereinfachen"],
	    ["simplification","for_polynomials","with_minus"]))];
moveActiveRoot 1;
autoCalculate 1 CompleteCalcHead;
autoCalculate 1 (Step 1);
autoCalculate 1 (Step 1);
val ((pt,p),_) = get_calc 1; show_pt pt;
"----- 1 ^^^";
fetchApplicableTactics 1 0 p;
val appltacs = sel_appl_atomic_tacs pt p;
applyTactic 1 p (hd appltacs) (*addiere_x_plus_minus*);
val ((pt,p),_) = get_calc 1; show_pt pt;
"----- 2 ^^^";
trace_rewrite := true;
val t = str2term "- 9 + 12 + 5 * e - 7 * e + (6 - 4) * f - 8 * g + 10 * g";
val Some (t',_) = 
    rewrite_ Isac.thy e_rew_ord erls_ordne_alphabetisch false tausche_minus t;
term2str t';     "- 9 + 12 + 5 * e - 7 * e + (- 4 + 6) * f - 8 * g + 10 * g";
trace_rewrite := false;


applyTactic 1 p (hd (sel_appl_atomic_tacs pt p)) (*tausche_minus*);
val ((pt,p),_) = get_calc 1; show_pt pt;
"----- 3 ^^^";
applyTactic 1 p (hd (sel_appl_atomic_tacs pt p)) (**);
val ((pt,p),_) = get_calc 1; show_pt pt;
"----- 4 ^^^";
applyTactic 1 p (hd (sel_appl_atomic_tacs pt p)) (**);
val ((pt,p),_) = get_calc 1; show_pt pt;
"----- 5 ^^^";
applyTactic 1 p (hd (sel_appl_atomic_tacs pt p)) (**);
val ((pt,p),_) = get_calc 1; show_pt pt;
"----- 6 ^^^";

(*<CALCMESSAGE> failure </CALCMESSAGE>
applyTactic 1 p (hd (sel_appl_atomic_tacs pt p)) (**);
val ((pt,p),_) = get_calc 1; show_pt pt;
"----- 7 ^^^";
*)

autoCalculate 1 CompleteCalc;
val ((pt,p),_) = get_calc 1; show_pt pt;
(*independent from failure above: met_simp_poly_minus not confluent:
(([9], Res), - (8 * g) + 10 * g + (3 - 2 * e + 2 * f)),
(([], Res), - (8 * g) + 10 * g + (3 - 2 * e + 2 * f))]
~~~~~~~~~~~###~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*)

(*
use"../smltest/IsacKnowledge/polyminus.sml";
use"polyminus.sml";
  *)

states:=[];
CalcTree [(["term ((- 4 + 6) * f)",
	    "normalform N"],
	   ("PolyMinus.thy",["polynom","vereinfachen"],
	    ["simplification","for_polynomials","with_minus"]))];
moveActiveRoot 1;
autoCalculate 1 CompleteCalc;
val ((pt,p),_) = get_calc 1; show_pt pt;
